<?php

namespace Waggybytes\SimplyRemindMe\Library\Localisation;

use Carbon\Carbon;
use Waggybytes\SimplyRemindMe\Library\Models\User;

class DateTimeHandlerParser
{
    public function __construct(private DateTimeHandler $converter)
    {
    }

    /**
     * Uses the current input value as-is without doing any conversion on the timezone.
     * @return DateTimeHandler
     */
    public function useAsIs()
    {
        $date = new Carbon($this->converter->parseInput());
        $this->converter->overrideCurrent($date);

        return $this->converter;
    }

    public function fromUserTimezone(User $user)
    {
        $date = new Carbon($this->converter->parseInput(), $user->timezone->identifier);
        $this->converter->overrideCurrent($date);

        return $this->converter;
    }

    public function fromUTC()
    {
        $date = new Carbon($this->converter->parseInput(), 'UTC');
        $this->converter->overrideCurrent($date);

        return $this->converter;
    }
}