<?php

namespace Waggybytes\SimplyRemindMe\Library\Models;

use Illuminate\Database\Eloquent\Model;

class SmsPack extends Model
{
    protected $casts = [
        'price_per_credit' => 'float',
        'user_price' => 'float'
    ];

    protected $fillable = ['name', 'number_credits', 'user_price', 'our_cost', 'valid_at', 'invalid_at'];

    protected $hidden = ['our_cost', 'valid_at', 'invalid_at'];

    public function currencyPrices()
    {
        return $this->hasMany(SmsPackCurrencyPrice::class);
    }

    public function toArrayPublic()
    {
        return [
            'name' => $this->name,
            'number_credits' => $this->number_credits,
            'price' => $this->user_price,
            'price_per_credit' => $this->price_per_credit
        ];
    }
}