<?php

namespace Waggybytes\SimplyRemindMe\Library\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\App;

class Timezone extends Model
{
    protected $fillable = ['identifier', 'description', 'offset'];

    /**
     * Gets the timezone representing the server's current timezone.
     * @return Timezone
     */
    public static function getCurrent()
    {
        $tz = Timezone::where('identifier', date_default_timezone_get())->first();
        if (is_null($tz))
        {
            App::abort(404);
        }

        return $tz;
    }

    /**
     * Gets the timezone representing UTC.
     * @return Timezone
     */
    public static function getUTC()
    {
        $tz = Timezone::where('identifier', 'UTC')->first();
        if (is_null($tz))
        {
            App::abort(404);
        }

        return $tz;
    }
}
